%:-include('./sbds_opti.pl').

% constraints between successives variables
knight_successif([],[],[],[],_,_,_):-!.
knight_successif([Elt_m|M],[Elt_n|LN],[DirX|LX],[DirY|LY],Im,Jm,N):-
	(fd_element(Mov,[3,1,4,0,4,0,3,1],DirX)),
	(fd_element(Mov,[4,0,3,1,1,3,0,4],DirY)),
	Lc=[In,Jn],
	fd_domain(Lc,1,N),

	Elt_n#=#(In-1)*N+Jn,
	
	In#=#Im+DirX-2,
	Jn#=#Jm+DirY-2,

	knight_successif(M,LN,LX,LY,In,Jn,N).

% Display solution

position_list([],_,_,0):-!.
position_list([X|_],X,N1,N1):-!.
position_list([_|T],X,N1,N2):-
	N3 is N1+1,
	position_list(T,X,N3,N2).
	

prime_to_pos(_,[],0):-!.
prime_to_pos(L,[Pos|T],N):-
	position_list(L,N,1,Pos),
	N2 is N-1,
	prime_to_pos(L,T,N2).



write_lgn([]):-!.
write_lgn([X|L]):-
	(X>9->write(X),write('|')
		;
		write(X),write(' |')),
	write_lgn(L),!.
	
write_sol([],_):-!.
write_sol(Lpos,N):-
	length(Ligne,N),
	append(Ligne,Rest,Lpos),
	write_lgn(Ligne),nl,
	write_sol(Rest,N)
.

% Liste pair/impair
im_pair([],0):-!.
im_pair([],-1):-!.
im_pair([N|L],N):-
	N2 is N-2,
	im_pair(L,N2),!.

impairList([],[]):-!.
impairList([I],[I]):-!.
impairList([I|[_|L]],[I|L2]):-
	impairList(L,L2).

% parity constraint (white square)
plusN([],[],_).
plusN([Y|TY],[X|TX],N):-
	X is Y+N,
	plusN(TY,TX,N).

parity(L,L,_,1):-!.
parity(Lprec,L,Nfix,N):-
	append(Lprec,L2,L),
	Parity is N/\1,
	(Parity=1 -> Np is Nfix-1,plusN(Lprec,Lnew,Np);
		Np is Nfix+1, plusN(Lprec,Lnew,Np)),
	N2 is N-1,
	parity(Lnew,L2,Nfix,N2).

% domaines des primes
dom_primes([],_,_):-!.
dom_primes([H],Dom1,_):-
	fd_domain(H,Dom1),!.
dom_primes([H1|[H2|T]],Dom1,Dom2):-
	fd_domain(H1,Dom1),
	fd_domain(H2,Dom2),
	dom_primes(T,Dom1,Dom2).

% Queen Choice
queenchoice([H|_],H,N,N).
queenchoice([_|T],H2,N1,N2):-
	N3 is N1+1,
	queenchoice(T,H2,N3,N2).

% Queen Constraint
queenconst([],_,_,_,_,_,_):-!.
queenconst([Elt|L],Iq,Jq,2,Prime,N,Queen):-
	!, %Queen#\=Elt,
	I2 is 3,
	fd_domain(Ip,1,N),
	fd_domain(Jp,1,N),
	Elt#=#(Ip-1)*N+Jp,
	fd_only_one([Ip#=#Iq, Jp#=#Jq]),
	%(Ip#=#Iq; Jp#=#Jq),
	queenconst(L,Iq,Jq,I2,Prime,N,Queen)
	.
queenconst([Elt|L],Iq,Jq,I,Prime,N,Queen):-
%	write('queen const 01a'-I),nl,
	member(I,Prime),!,
	Queen#\=Elt,
	I2 is I+1,
	fd_domain(Ip,1,N),
	fd_domain(Jp,1,N),
	Elt#=#(Ip-1)*N+Jp,
%	write('queen const 03'-Ip-Jp-Iq-Jq),nl,	
%	((Ip#=Iq #\/ Jp#=Jq )#\/ (Ip-Iq)*(Ip-Iq)#=(Jp-Jq)*(Jp-Jq)),
%	(Ip#=#Iq #\/ Jp#=#Jq )#\/ ( (Ip#\=Iq)#/\(Jp#\=Jq)#/\((Ip-Iq#=#Jp-Jq) #\/ (Jp-Jq#=#Iq-Ip) #\/ (Iq-Ip#=#Jq-Jp) #\/ (Jq-Jp#=#Ip-Iq))),
	fd_domain(Diag,0,1),
	fd_cardinality([(Ip+Jq#=#Jp+Iq),(Jp+Ip#=#Iq+Jq)],Diag),
	fd_only_one([Ip#=#Iq, Jp#=#Jq ,Diag#=#1]),
%	write('Diag'-Diag),nl,
%	write('queen const 04'),nl,
	queenconst(L,Iq,Jq,I2,Prime,N,Queen)
	.
queenconst([_|L],Iq,Jq,I,Prime,N,Queen):-
%	write('queen const 01b'-I),nl,
	\+member(I,Prime),
%	write('queen const 02b'),nl,
	I2 is I+1,
%	write('queen const 03b'),nl,
	queenconst(L,Iq,Jq,I2,Prime,N,Queen).
	
noattackqueen([],_,_,_,_).
noattackqueen([Elt|L],Iq,Jq,N,Queen):-
	Elt#\=Queen,
	Elt#=#(Ip-1)*N+Jp,
	Ip#\=#Iq,
	Jp#\=#Jq,
	Ip+Jq#\=#Jp+Iq,
	Jp+Ip#\=#Iq+Jq,
	Iq+Jq#\=#Jp+Ip,
	Iq+Jp#\=#Jq+Ip,
	noattackqueen(L,Iq,Jq,N,Queen).
	
listN([N],N,N):-!.
listN([I|L],I,N):-
	I2 is I+1,
	listN(L,I2,N).
	
attackedsquare_black(Ip-Jp,Iq,Jq,N,K):-
	Ip is Iq+K,
	Jp is Jq+K,
	Ip=<N,Jp=<N,
	integer(Ip),integer(Jp),integer(K).
attackedsquare_black(Ip-Jp,Iq,Jq,N,K):-
	Ip is Iq-K,
	Jp is Jq+K,
	Ip>=1,Jp=<N,
	integer(Ip),integer(Jp),integer(K).
attackedsquare_black(Ip-Jp,Iq,Jq,N,K):-
	Ip is Iq+K,
	Jp is Jq-K,
	Jp>=1,Ip=<N,
	integer(Ip),integer(Jp),integer(K).
attackedsquare_black(Ip-Jp,Iq,Jq,_,K):-
	Ip is Iq-K,
	Jp is Jq-K,
	Jp>=1,Ip>=1,
	integer(Ip),integer(Jp),integer(K).
attackedsquare_black(Ip-Jp,Iq,Jq,N,K):-
	Ip is Iq,
	Jp is Jq+K,
	Jp=<N.
attackedsquare_black(Ip-Jp,Iq,Jq,_,K):-
	Ip is Iq,
	Jp is Jq-K,
	Jp>=1.
attackedsquare_black(Ip-Jp,Iq,Jq,N,K):-
	Jp is Jq,
	Ip is Iq+K,
	Ip=<N.
attackedsquare_black(Ip-Jp,Iq,Jq,_,K):-
	Jp is Jq,
	Ip is Iq-K,
	Ip>=1.


conversion_coord(X,Y,P,N):-
	P is (X-1)*N+Y.

primevars(_,[],N,N,_):-!.
primevars([X|L],[X|L2],I,N,Primes):-
	member(I,Primes),!,
	I2 is I+1,
	primevars(L,L2,I2,N,Primes).
primevars([_|L],L2,I,N,Primes):-
	\+ member(I,Primes),
	I2 is I+1,
	primevars(L,L2,I2,N,Primes).	

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	
reduction_var(_,[]):-!.
reduction_var(Var,[Val|L]):-
	Var#\=Val,
	reduction_var(Var,L).
reduction_list_var([],_):-!.	
reduction_list_var([Var|L],LVal):-
	reduction_var(Var,LVal),
	reduction_list_var(L,LVal).
	
% Main
primequeen(L,Lpos,N):-
	g_assign(primes,[2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,61,67,71,73,79,83,87,89,97]),
	g_assign(list_sol,[]),g_assign(nb_sol,0),
	
%	open('primequeen6.res', write, ResStream),
%	open('primequeen.esv', write, Esieve),
%	print_esieve_header(Esieve),
%	close(Esieve),
	
	g_read(primes,Primes),

	N2 is N*N,
	length(L,N2),
	
	im_pair(Ldom1,N2),
	Nmoins1 is N2-1, im_pair(Ldom2,Nmoins1),
	
	fd_domain(L,1,N2),
	L=[First|Tail],Tail=[Second|Tail2],Tail2=[Third|_],
	
	% constraint of geometric symmetry
%	N3 is (N*N+1)//2,
%	N4 is (N+1)//2,
%	First#=<N3,
%	First#=(If-1)*N+Jf,
%	Cf=[If,Jf],
%	fd_domain(Cf,1,N4),	
%	If#=<Jf,
	
	% all_diff constraint
	write('all diff'),nl,
	fd_all_different(L), 
	
	% parity constraint
	write('parity constraint'),nl,
	Parity is N /\ 1,
%	write('parity constraint 2'),nl,
	(Parity=:=0 ->  write('Parity = 0'),nl, % pair
			N11 is N-1,im_pair(Lparity,N11),
			parity(Lparity,LparityN,N,N),
			subtract(Ldom2,[1|Primes],DomQueen),fd_domain(NbQueen,DomQueen),
			flatten([Ldom1,Ldom2],LN2),
			subtract(LN2,LparityN,LBlack),
			dom_primes(L,LparityN,LBlack),
			OddSquares=LparityN,EvenSquares=LBlack,
			subtract(Ldom2,Primes,OddNoPrimes),
	%		First#=<N2//2, % Antisymetric constraint
			true
			;
			write('Parity = 1'),nl,	% impair	
			subtract(Ldom1,[1|Primes],DomQueen),
			fd_domain(NbQueen,DomQueen),
			(dom_primes(L,Ldom1,Ldom2),Black is 1,OddSquares=Ldom1,EvenSquares=Ldom2;dom_primes(L,Ldom2,Ldom1),Black is 0,	OddSquares=Ldom2,EvenSquares=LDom1),
			subtract(Ldom1,Primes,OddNoPrimes),
			fd_domain(IFirst,1,N),fd_domain(JFirst,1,N),
	%		First#=(IFirst-1)*N+JFirst,
	%		IFirst#=< N//2+1,JFirst#=<N//2+1, % Antisymetric constraint
	%		First#=<N2//2+1,
			true 
			
		), 
	
	
%	write('L='-L),nl,
		
	write('knight constraint'),nl,

%	indomain(First),
		
	% second constraint (knight constraint)
	append(Head,[_],L),
	length(Head,NDir),
	length(DirectionX,NDir), length(DirectionY,NDir),
	fd_domain(DirectionX,0 ,4), fd_domain(DirectionY, 0,4),
	fd_domain(Im,1,N), fd_domain(Jm,1,N),
	First#=#(Im-1)*N+Jm,
	knight_successif(Head,Tail,DirectionX,DirectionY,Im,Jm,N),
	write('prime queen constraint'),nl,
	
	% prime-queen constraint
	
%	member(NbQueen,Ldom1),
%	impairList(L,Limpair),
	
%	NbQueen#=49, % N=7
	fd_labeling(NbQueen,[value_method(middle)]),
%	queenchoice(L,Queen,1,NbQueen),
	nth(NbQueen,L,Queen),
%	fd_size(Queen,SizeQueen),
%	SizeQueen>Nb_primes,

	
%	member(Queen,Limpair),
%	element(_,Limpair,Queen),

%	writeln(Queen),

%	Queen#=25, % N=7
%	write('toto2b '),write(NbQueen-Queen),nl,
%	Queen#=17,
%	Third#=8,

	fd_domain(Iq,1,N),fd_domain(Jq,1,N),
	write('toto2c '),nl,
	Queen#=#(Iq-1)*N+Jq,
	write('toto2d '),nl,
	
	queenconst(L,Iq,Jq,1,Primes,N,Queen),
%	write('toto3 '),
	fd_labeling(Queen,[value_method(middle)]),
%	fd_labeling2([Queen],L),
%	write('toto4 '),
	listN(ListN,1,N),
	findall(P, (member(K,ListN),attackedsquare_black(X-Y,Iq,Jq,N,K),conversion_coord(X,Y,P,N)),LAttSquare_aux),
	subtract(LAttSquare_aux,EvenSquares,LAttSquare),
	write('LAttSquare'),nl,
%	setof(PrimesVar,Iprimes^(member(Iprimes,Primes),nth(Iprimes,L,PrimesVar)),LPrimes),
	subtract(OddSquares,LAttSquare,LNoAttSquare),
%	write('LNoAttSquare'-LNoAttSquare),nl,
	
	primevars(L,VarPrimes,1,N2,Primes),
	

	reduction_list_var(VarPrimes,LNoAttSquare),

%	fd_domain(VarPrimes,LAttSquare),
	%write('LPrimes'-LPrimes),nl,
	
	% Validation of the position of Queen
	Aq1 is Iq-1,Bq1 is Jq-1,Aq2 is N-Iq,Bq2 is N-Jq,
	min_list([Aq1,Bq1],S1),min_list([Aq1,Bq2],S2),min_list([Aq2,Bq1],S3),min_list([Aq2,Bq2],S4),
	(Parity=:=0 -> % even size
		S5 is N-2 %2*(N//2-1)
		;
		ParityPos is Iq/\1,
		(Black=:=1->
			(ParityPos=:=1-> % odd position
				S5 is N
				;
				S5 is N-2 %2*(N//2-1)
			)
			;
			(ParityPos=:=0-> % even position
				S5 is N
				;
				S5 is N-2 %2*(N//2-1)
			)
		)
	),
	AttackedSquare is S1+S2+S3+S4+S5,
	nb_primes(N,Nb_primes),
	Nb_primes -1 =< AttackedSquare,	
	(Nb_primes-1 =:= AttackedSquare->%write('primes=attacked'),nl,
			noattackqueen(OddNoPrimes,Iq,Jq,N,Queen);true),
		
	



	
%	nth(9,L,Nine),
%	last(L,Last),Last#=49,
	write(('Queen '-Queen)),nl,
%	write(('Queen '-Queen-' Second'-Second-' Third'-Third-' Ninth'-Nine)),nl,
	
%	fd_labeling2(L,L),
%	prime_to_pos(L,Lpos,N2),
%	labeling_sbds(L,[sym_primeq],[5],[var_order(middle)]),
	randomize,
	labeling_sbds(L,[diag2_arr_val,vert_arr_val,hor_arr_val,diag1_arr_val,rot90_arr_val,rot180_arr_val,rot270_arr_val],[N],[val_order(random)]),
%	labeling_sbds(L,[]),
	g_read(nb_sol,Nb_Sol),Nb_Sol2 is Nb_Sol+1,g_assign(nb_sol,Nb_Sol2),
	write('Solution....'-Nb_Sol2),write('  La reine : '),write(NbQueen),nl,
%	write(ResStream,'primequeen('),write(ResStream,L),write(ResStream,','),write(ResStream,N),write(ResStream,','),write(ResStream,Queen),write(ResStream,').\n'),
%	close(ResStream),
	prime_to_pos(L,Lpos,N2),
	write('toto'),nl,
	write_sol(Lpos,N)
	%inc_sol(L,1),
%	fail
	.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Emulation of system predicates : indomain


middle_first([], []).
middle_first([X], [X]).
middle_first(L, L2):-
	append([A|R], [B], L),
	middle_first(R, R2),
	append(R2, [A|[B]], L2).



% A classical labeling procedure
all_dom([],[]).
all_dom([Var|L],[Dom|LDom]):-
	fd_dom(Var,Dom),
	all_dom(L,LDom).

labeled_var([],[]):-!.
labeled_var([Var|LVar],LNoLab):-
	fd_dom(Var,[_]),!,
%	write('Dom 1 '-Var-Dom),nl,
	labeled_var(LVar,LNoLab).
labeled_var([Var|LVar],[Dom|LDomNoLab]):-
	fd_dom(Var,Dom),
%	write('Dom N '-Var),nl,
	labeled_var(LVar,LDomNoLab).

check_dom(L):-
%	write('chk_dom1'),nl,
%	all_dom(L,LDom),
%	write('chk_dom2'),nl,
	labeled_var(L,NoLabeled_dom),
%	write('chk_dom3'),nl,
	length(NoLabeled_dom,N),
	flatten(NoLabeled_dom,Flat_dom),
	no_doublon(Flat_dom,Union_dom),
%	write('chk_dom6'),nl,
	length(Union_dom,Dom_lgth),
%	write('chk_dom6.5'),nl,
	Dom_lgth>= N,
%	write('chk_dom7 Taille dom valide'),nl,
	true
	.

fd_labeling2([],_).
fd_labeling2([V|R],L):-
	%deleteff(V, [X|L], R),
%	write('fd_labeling1'),nl,
	fd_size(V,Size),Size>1,!,
	fd_labeling(V,[value_method(middle)]),
%	write('fd_labeling2'),nl,
	check_dom(L),
%	write('fd_labeling3'),nl,
	fd_labeling2(R,L).
fd_labeling2([_|R],L):-
	fd_labeling2(R,L).

labeling2([]).
labeling2([Var|Rest]) :-
%	writeln("debut labeling"),
%	writeln(Var),
	%indomain(Var,middle),
%	fd_dom(Var,Dom),
%	write(Var),nl,
	labeling2(Rest).



% Esieve
fields([field("Var",  "Integer",  "-",    "-"),
       field("Val",   "Integer", "-",    "-"),
       field("Nb Sol",  "Integer", "-",    "-")]).

%print_esieve_header(Esieve):-
%	fields(Fields),
%	( member(field(Name,_,_,_), Fields),
%	  printf(Esieve, "%s\t", Name),
 %         fail
  %      ; printf(Esieve, "\n", []) ),
%	( member(field(_,Type,_,_), Fields),
%	  printf(Esieve, "%s\t", Type),
 %         fail
  %      ; printf(Esieve, "\n", []) ),
%	( member(field(_,_,Enum,_), Fields),
%	  printf(Esieve, "%s\t", Enum),
 %         fail
  %      ; printf(Esieve, "\n", []) ),
%	( member(field(_,_,_,Date), Fields),
%	  printf(Esieve, "%s\t", Date),
 %         fail
  %      ; printf(Esieve, "\n", []) ),
%	  printf(Esieve, "\n", []).


inc_sol([],_).
inc_sol([H|T],I):-
	g_read(list_sol,List_sol),
	X=I-H-Nb,
	(member(X,List_sol) -> 
		subtract(List_sol,[X],List_sol2),
		Nb2 is Nb+1,
		g_assign(list_sol,[I-H-Nb2|List_sol2])
		;
		Nb2 is 1,
		g_assign(list_sol,[I-H-Nb2|List_sol])
	),
	I2 is I+1,
	inc_sol(T,I2).
	
%print_lgn_esv([],_).
%print_lgn_esv([Var-Val-Nb|T],Esieve):-
	%printf(Esieve, "%d\t%d\t%d\t\n",[Var,Val,Nb]),
%	print_lgn_esv(T,Esieve).
	
%write_esv:-
%	open('primequeen.esv', write, Esieve),
%	g_read(list_sol,List_sol),
	%print_lgn_esv(List_sol),
%	close(Esieve).

% Conversion duale variable valeur
build_dual([],_,_,_):-write('error dual'),fail.
build_dual([Val|_],Pos,Val,Pos):-!.
build_dual([_|T],Pos,Val,I):-	
	I2 is I+1,
	build_dual(T,Pos,Val,I2).
	
dual([],_,_).
dual([H|T],L,I):-
	build_dual(L,H,I,1),
	I2 is I+1,
	dual(T,L,I2).

%pq5(L,_,_),length(L2,25),dual(L,L2,1),(primequeen(L2,5)->fail;write('fail'),nl,nl).

nb_primes(5,9).
nb_primes(6,11).
nb_primes(7,15).
nb_primes(8,17).
nb_primes(9,21).
nb_primes(10,25).
