% SBDS en GNU Prolog
% Guillaume Arnaud
% Date : 25/04/2003
% Gestion des permutations en prolog pour la SBDS
%

% Init arrays of symmetries
initialisation_sym_array_pl(NbVar,NbVal,NbSym,1):-
	NbValp1 is NbVal+1,
	NbAff is NbVar*NbValp1,
	NbSymp1 is NbSym+1,
	g_assign(nbval_pl,NbVal),
	g_assign(nbsym,NbSymp1),
	g_assign(nbaff,NbAff),
	g_assign(perm_point,g_array(NbSymp1,g_array(NbAff))).
	
initialisation_sym_array_pl(NbVar,NbVal,NbSym,2):-
	NbValp1 is NbVal+1,
	NbSymp1 is NbSym+1,
	g_assign(nbsym,NbSymp1),
	g_assign(nbvar,NbVar),
	g_assign(nbval,NbVal),
	g_assign(perm_var,g_array(NbSymp1,g_array(NbVar))),
	g_assign(perm_val,g_array(NbSymp1,g_array(NbValp1))).

% Init elements of an array
set_var_pl(NumSym,IVar,IVarSym):-
%	NumSymm1 is NumSym-1,
	IVarm1 is IVar-1,
	g_assign(perm_var(NumSym,IVarm1),IVarSym).
	
set_val_pl(NumSym,Val,ValSym):-
	g_assign(perm_val(NumSym,Val),ValSym).
	
set_point_pl(NumSym,Ind,IndSym):-
	g_assign(perm_point(NumSym,Ind),IndSym).

% get elements of an array
get_var_pl(NumSym,IVar,IVarSym):-
%	NumSymm1 is NumSym-1,
	IVarm1 is IVar-1,
	g_read(perm_var(NumSym,IVarm1),IVarSym).
	
get_val_pl(NumSym,Val,ValSym):-
	g_read(perm_val(NumSym,Val),ValSym).

get_point_pl(NumSym,Ind,IndSym):-
	g_read(perm_point(NumSym,Ind),IndSym).

% compute symmetry of a point	
image_sym_pl_1(NumSym,IVar,Val,IVarSym,ValSym):-
	g_read(nbval_pl,NbVal),
	Point is (IVar-1)*NbVal+Val+1,

	g_read(perm_point(NumSym,Point),PointSym),

	(PointSym=Point->
			fail;
			IVarSym is (PointSym-1)//NbVal+1,
			ValSym is (PointSym-1) mod NbVal).

% compute symmetry of a (IVar,Val)	
image_sym_pl_2(NumSym,IVar,Val,IVarSym,ValSym):-
%	NumSymm1 is NumSym-1,
	IVarm1 is IVar-1,
	g_read(perm_var(NumSym,IVarm1),IVarSym),
	g_read(perm_val(NumSym,Val),ValSym),

	((IVarSym=IVar,ValSym=Val)-> fail; true).

% extend array of symmetries
add_sym(1):-
	g_read(nbaff,NbAff),
	g_read(nbsym,NbSym),
	NbSymp1 is NbSym+1,
	g_assign(nbsym,NbSymp1),

	g_assign(perm_point,g_array_extend(NbSymp1,g_array(NbAff))).

add_sym(2):-
	g_read(nbvar,NbVar),
	g_read(nbval,NbVal),
	g_read(nbsym,NbSym),
	NbSymp1 is NbSym+1,
	g_assign(nbsym,NbSymp1),
	
	g_assign(perm_var,g_array_extend(NbSymp1,g_array(NbVar))),
	g_assign(perm_val,g_array_extend(NbSymp1,g_array(NbVal))).
